/*
 *
 *  Copyright 2019 Gleb Popov <6yearold@gmail.com>
 *
 *  Redistribution and use in source and binary forms, with or without modification,
 *  are permitted provided that the following conditions are met:
 *  1. Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright notice,
 *  this list of conditions and the following disclaimer in the documentation
 *  and/or other materials provided with the distribution.
 *  3. Neither the name of the copyright holder nor the names of its contributors may
 *  be used to endorse or promote products derived from this software without specific
 *  prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 *  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 *  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 *  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 *  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 *  OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 *  ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
*/

#ifndef CAMCONTROLPROBER_H
#define CAMCONTROLPROBER_H

enum camdevicetype
{
    CAM_DT_ATA,
    CAM_DT_SCSI
};

enum camtransport
{
    CAM_TR_USB,
    CAM_TR_SCSI,
    CAM_TR_ATA,
    CAM_TR_UNKNOWN
};

struct camcontrolreturn
{
    char serial[128];
    enum camtransport transport;
    int is_sata;
    int is_removable;
};

#ifdef __cplusplus

#include <QObject>
#include <QRunnable>

class CamControlProber : public QObject,  public QRunnable
{
    Q_OBJECT
public:
    CamControlProber(const QString& dev);

    void run() override;

signals:
    void finished(const QString& serial, bool isRemovable, int transport, bool isAtaSata);

private:
    QString m_dev;
};

#endif // __cplusplus
#endif // CAMCONTROLPROBER_H
